## Общая структура графического драйвера

```
    ┌───────────────────────────┐
    │                           │
    │    Контроллер дисплеев    │
    │                           │
    └─────────────▴─────────────┘
                  │
    ┌─────────────┴─────────────┐
    │                           │
    │    Графический драйвер    │
    │          (devg-*)         │
    │                           │
    └─────────────▴─────────────┘
                  │
                  *
                  │
    ┌─────────────┴─────────────┐         ┌───────────────────────────┐
    │                           │         │                           │
    │    Менеджер io-display    ◂─── * ───┤   Клиентское приложение   │
    │                           │         │                           │
    └───────────────────────────┘    ▲    └───────────────────────────┘
                                     │
                                     │
              Интерфейс libgf ───────┘
```



## Дерево исходных кодов

```
|- devg/devnp/
|  |- lib/              - Вспомогательные библиотеки
|  |- private/          - Приватные хедеры графической подсистемы
|  |- public/           - Публичные хедеры графической подсистемы
|  |- vesabios/         - Исходный код универсального драйвера контроллера дисплеев (группа стандартов VESA)
|  |- vpoutfb/          - Исходный код драйвера контроллера дисплеев для Элвис 1892ВМ14Я (ARMv7 SoC)
|  |- common.mk         - Параметры сборки драйверов
|  `- Makefile          - Правила сборки дерева исходников
|
`- Makefile             - Правила сборки дерева исходников
```



## Сборка драйвера

- Установить и настроить [комплект разработчика](https://help.kpda.ru/neutrino/2020/help/topic/ru.kpda.doc.dev_tools_ru/html/devkit/devkit.html) для [ЗОСРВ "Нейтрино" редакции 2020](https://help.kpda.ru/neutrino/2020/help/index.jsp).
- Выполнить команду:

```
make
```



## Запуск драйвера

Общая схема запуска драйвера:

```
io-display -dvid=0x0,did=0x0
```

Особенности запуска и настройки графических драйверов представлены в статье [Настройка графической подсистемы](https://help.kpda.ru/neutrino/2020/help/topic/ru.kpda.doc.graphics_ru/html/user_guide/guide/configuration.html).

