/*
 * (c) 2020, SWD Embedded Systems Limited, http://www.kpda.ru
 */


#ifndef _GRAPHICS_REND_H_INCLUDED
#define _GRAPHICS_REND_H_INCLUDED

typedef struct disp_rend_buffer_config {
	unsigned	color_format;				/* See DISP_LAYER_FORMAT_* */
	unsigned	read_format;				/* See DISP_TEXFORMAT_* */
	unsigned	red_bpp;				/* Red bits per pixel of color buffer */
	unsigned	green_bpp;				/* Green bits per pixel of color buffer */
	unsigned	blue_bpp;				/* Blue bits per pixel of color buffer */
	unsigned	alpha_bpp;				/* Alpha bits per pixel of color buffer */
	unsigned	depth_bpp;				/* Bits per pixel of depth buffer */
	unsigned	stencil_bpp;				/* Bits per pixel of stencil buffer */
	int		max_surf_width;				/* Maximum width of a buffer, in pixels, that can be rendered to */
	int		max_surf_height;			/* Maximum height of a buffer, in pixels, that can be rendered to */
	int		slow_config;
	unsigned	sample_buffers;
	unsigned	samples;
	unsigned	reserved[6];				/* Must be zero */
} disp_rend_buffer_config_t;

typedef struct disp_rend_context_params {
	void * (*get_current_context)();
} disp_rend_context_params_t;

#endif /* _GRAPHICS_REND_H_INCLUDED */
